#include <stdio.h>
#include <stdint.h>

#define N		20

#define BITS		8
#define TYPE		uint8_t

#define LIMBS		((N + BITS - 1) / BITS)
				// N / BITS rounded up
#define LIMB_MAX	((TYPE)-1)

#define LIMB_LAST_MAX	(LIMB_MAX >> ((LIMBS * BITS) - N))

void popcount_all(void)
{
	TYPE j[LIMBS];

	for (int l = 0; l < LIMBS; l++) {
		j[l] = 0;
	}

	while (1) {
		for (int l = 0; l < LIMBS; l++) {
			if ((l == LIMBS - 1) && (j[l] == LIMB_LAST_MAX))
				return;

			if (j[l] < LIMB_MAX) {
				j[l] = j[l] + 1;
				break;
			}

			j[l] = 0;

			if (l + 1 >= LIMBS) {
				printf("Overflow\n");
				return;
			}
		}

		for (int l = LIMBS - 1; l >= 0; l--) {
			printf(" %4d", j[l]);
		}

		printf(" ");

		int count = 0;

		for (int b = N - 1; b >= 0; b--) {
			int l = b / BITS;
			int lb = b % BITS;

			TYPE mask = ((TYPE)1) << lb;

			int value;

			if ((j[l] & mask) != 0) {
				value = 1;
			} else {
				value = 0;
			}

			count = count + value;

			printf("%d", value);
		}

		printf(": %d\n", count);
	}
}

int main()
{
	popcount_all();
	return 0;
}
